您的位置:首页 > 其它

poj_3126 Prime Path(bfs)

2016-11-12 00:11 357 查看
Prime Path

Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 18161 Accepted: 10222
Description


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 

— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 

— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 

— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033

1733

3733

3739

3779

8779

8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033

Sample Output
6
7
0

先筛出10000以内的所有素数,然后bfs模拟。

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <stack>
#include <bitset>
#include <queue>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#define FOP freopen("data.txt","r",stdin)
#define inf 0x3f3f3f3f
#define maxn 1000010
#define mod 1000000007
#define PI acos(-1.0)
#define LL long long
using namespace std;

int prime[10010];

void init()
{
for(int i = 1; i <= 10000; i++)
{
for(int j = i; j <= 10000; j += i)
{
prime[j]++;
}
}
}

struct Node
{
int val[4];
};
int s, e;
int st[4];
bool vis[10010];

int solve(int *a)
{
int res = 0;
for(int i = 3; i >= 0; i--)
{
res = res * 10 + a[i];
}
return res;
}

int path[10010];

void bfs()
{
memset(path, 0, sizeof(path));
memset(vis, 0, sizeof(vis));

queue<Node> Q;
Node t;
for(int i = 0; i < 4; i++) t.val[i] = st[i];
Q.push(t), vis[s] = 1;

while(!Q.empty())
{
t = Q.front();
Q.pop();
int p = solve(t.val);
if(p == e) break;

for(int i = 0; i < 4; i++)
{
for(int j = 0; j <= 9; j++)
{
if(i == 3 && j == 0) continue;
int temp;
if(t.val[i] != j)
{
temp = t.val[i];
t.val[i] = j;
int num = solve(t.val);
if(!vis[num] && prime[num] == 2)
{
vis[num] = 1;
Q.push(t);
path[num] = path[p] + 1;
}
t.val[i] = temp;
}
}
}
}

}

int main()
{
init();

int T;
scanf("%d", &T);

while(T--)
{
scanf("%d%d", &s, &e);
int t = s, c = 0;
while(t)
{
st[c++] = t % 10;
t /= 10;
}
bfs();
printf("%d\n", path[e]);
}

return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: